package SortAlgori;

import java.util.Scanner;

public class BubbleSort {

    private int[] arr;

    public BubbleSort(String str){
        String[] splitArrs = str.split(";");
        arr = new int[splitArrs.length];
        for (int i = 0; i < splitArrs.length; i++) {
            arr[i] = Integer.parseInt(splitArrs[i]);
        }
    }

    public BubbleSort(int[] arr){
        this.arr = arr;
    }


    /**
     * 可以进行一个优化，如果在某一趟排序中没发生过交换，就说明已经排好序了
     */
    public void sort(){
        boolean flag = false;
        for (int i=0 ; i<arr.length-1; i++){
            for(int j=0; j<arr.length-i-1; j++){
                if(arr[j]>arr[j+1]){
                    flag = true;
                    int temp = arr[j+1];
                    arr[j+1] = arr[j];
                    arr[j] = temp;
                }
            }
            if(!flag){
                break;
            }else {
                flag = false;
            }
        }
    }

    public void show(){
        for (int i = 0; i < arr.length; i++) {
            System.out.print(arr[i] + " ");
        }
        System.out.println();
    }

    public static void main(String[] args) {
        int[] arr = new int[50000];
        System.out.println("排序前的序列：");
        for(int i=0; i<50000; i++){
            arr[i] = (int)(Math.random()*1000000);
            System.out.print(arr[i] + " ");
        }
        System.out.println();
        BubbleSort bubbleSort = new BubbleSort(arr);
        long startTime = System.currentTimeMillis();
        bubbleSort.sort();
        long endTime = System.currentTimeMillis();
        System.out.println("排序后的序列：");
        bubbleSort.show();
        System.out.println("排序所花费的时间：" + (endTime - startTime) + "ms");
    }
}
